import { type PropType, type ComputedRef } from 'vue';
import type { AllItems, Item, Hook } from './types';
export declare type Context = {
    focusNext(): void;
    focusPrevious(): void;
    clearFocus(): void;
    setFocusByKey(key?: string | null | undefined): void;
    setFocusByIndex(index: number): void;
    onSelect(fn: Hook): void;
    onFocus(fn: Hook): void;
    onUnfocus(fn: Hook): void;
    onHover(fn: Hook): void;
    onDOMFocus(fn: Hook): void;
    getItemMetaByKey<Meta = any>(key: string): Meta | undefined;
    getSelectableItemCount(): number;
    getSelectableItems<Meta = unknown>(): Item<Meta>[];
    selectFocusedElement(): void;
    getFocusedItem<Meta = unknown>(): Item<Meta> | undefined;
    getItemElementByKey(key: string): HTMLElement | undefined;
    getItemElementByIndex(index: number): HTMLElement | undefined;
    scrollToFocusedItemElement(options?: ScrollIntoViewOptions): void;
    getFocusedItemElement(): HTMLElement | undefined;
};
export interface Props {
    noWrapperElement: boolean;
    items: AllItems[];
    setup(context: Context): void;
    onSelect(meta: any, item: Item<any>, el: HTMLElement): void;
    onItemFocus(meta: any, item: Item<any>, el: HTMLElement): void;
    onItemUnfocus(meta: any, item: Item<any>, el: HTMLElement): void;
    onItemDOMFocus(e: FocusEvent, meta: any, item: Item<any>): void;
    onItemHover(meta: any, item: Item<any>, el: HTMLElement): void;
}
declare const _default: import("vue").DefineComponent<{
    noWrapperElement: {
        type: PropType<boolean>;
        default: boolean;
    };
    items: {
        type: PropType<AllItems<any>[]>;
        default: () => any[];
    };
    setup: {
        type: PropType<(context: Context) => void>;
        default: any;
    };
}, {
    selectableItems: ComputedRef<Item<unknown, unknown, unknown, Record<string, unknown>, {
        key?: undefined;
        ref?: import("vue").Ref<HTMLElement> | ((el: HTMLElement) => void);
    } & Record<string, unknown>>[]>;
    focusedItemKey: import("vue").Ref<string>;
    handleDOMFocus: (event: FocusEvent, item: Item<unknown>) => void;
    handleMouseEnter: (item: Item) => void;
    handleClick: (item: Item) => void;
    isFocused: (key: string) => boolean;
    isDisabled: (key: string) => boolean;
    setFocusByKey: (key?: string) => void;
    selectItem: (queryKey?: string) => void;
    saveSelectableItemElement: (key: string, element: HTMLElement) => any;
}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    select: (meta: any, item: Item<any, unknown, unknown, Record<string, unknown>, {
        key?: undefined;
        ref?: import("vue").Ref<HTMLElement> | ((el: HTMLElement) => void);
    } & Record<string, unknown>>, el: HTMLElement) => void;
    itemFocus: (meta: any, item: Item<any, unknown, unknown, Record<string, unknown>, {
        key?: undefined;
        ref?: import("vue").Ref<HTMLElement> | ((el: HTMLElement) => void);
    } & Record<string, unknown>>, el: HTMLElement) => void;
    itemUnfocus: (meta: any, item: Item<any, unknown, unknown, Record<string, unknown>, {
        key?: undefined;
        ref?: import("vue").Ref<HTMLElement> | ((el: HTMLElement) => void);
    } & Record<string, unknown>>, el: HTMLElement) => void;
    itemDOMFocus: (e: FocusEvent, meta: any, item: Item<any, unknown, unknown, Record<string, unknown>, {
        key?: undefined;
        ref?: import("vue").Ref<HTMLElement> | ((el: HTMLElement) => void);
    } & Record<string, unknown>>) => void;
    itemHover: (meta: any, item: Item<any, unknown, unknown, Record<string, unknown>, {
        key?: undefined;
        ref?: import("vue").Ref<HTMLElement> | ((el: HTMLElement) => void);
    } & Record<string, unknown>>, el: HTMLElement) => void;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    noWrapperElement: {
        type: PropType<boolean>;
        default: boolean;
    };
    items: {
        type: PropType<AllItems<any>[]>;
        default: () => any[];
    };
    setup: {
        type: PropType<(context: Context) => void>;
        default: any;
    };
}>> & {
    onSelect?: (meta: any, item: Item<any, unknown, unknown, Record<string, unknown>, {
        key?: undefined;
        ref?: import("vue").Ref<HTMLElement> | ((el: HTMLElement) => void);
    } & Record<string, unknown>>, el: HTMLElement) => any;
    onItemFocus?: (meta: any, item: Item<any, unknown, unknown, Record<string, unknown>, {
        key?: undefined;
        ref?: import("vue").Ref<HTMLElement> | ((el: HTMLElement) => void);
    } & Record<string, unknown>>, el: HTMLElement) => any;
    onItemUnfocus?: (meta: any, item: Item<any, unknown, unknown, Record<string, unknown>, {
        key?: undefined;
        ref?: import("vue").Ref<HTMLElement> | ((el: HTMLElement) => void);
    } & Record<string, unknown>>, el: HTMLElement) => any;
    onItemDOMFocus?: (e: FocusEvent, meta: any, item: Item<any, unknown, unknown, Record<string, unknown>, {
        key?: undefined;
        ref?: import("vue").Ref<HTMLElement> | ((el: HTMLElement) => void);
    } & Record<string, unknown>>) => any;
    onItemHover?: (meta: any, item: Item<any, unknown, unknown, Record<string, unknown>, {
        key?: undefined;
        ref?: import("vue").Ref<HTMLElement> | ((el: HTMLElement) => void);
    } & Record<string, unknown>>, el: HTMLElement) => any;
}, {
    noWrapperElement: boolean;
    items: AllItems<any>[];
    setup: (context: Context) => void;
}>;
export default _default;
