import { type Component } from 'vue';
import type { AllItems, CustomItem, CustomItemOptions, Item, ItemGroup, ItemGroupOptions, ItemOptions } from './types';
export declare function itemGroup<WrapperComponent>(options: ItemGroupOptions<WrapperComponent>): ItemGroup<WrapperComponent>;
export declare function item<Meta = unknown, WrapperComponent = unknown, ElementTag = unknown>(options: ItemOptions<Meta, WrapperComponent, ElementTag>): Item<Meta, WrapperComponent, ElementTag>;
export declare function customItem<Meta = unknown>(options: CustomItemOptions<Meta>): CustomItem<Meta>;
export declare function isItemGroup(value: unknown): value is ItemGroup;
export declare function isItem<Meta = unknown>(value: unknown): value is Item<Meta>;
export declare function isCustomItem<Meta = unknown>(value: unknown): value is CustomItem<Meta>;
export declare function isComponent(value: unknown): value is Component;
export declare function filterSelectableAndCustomItems<Meta = unknown>(items: AllItems<Meta>[]): (Item<Meta> | CustomItem<Meta>)[];
export declare function filterSelectableItems<Meta = unknown>(items: AllItems<Meta>[]): Item<Meta>[];
